<?php

namespace app\admin\controller;

use app\BaseController;
use think\App;
use think\facade\Db;

class Check extends BaseController
{
public $post = "";
public function __construct(App $app)
{
    parent::__construct($app);
    $this->post=$this->request->post();
//    $token = isset($this->post['token']) ? trim($this->post['token']) : "";
//    if($token==""){
//        return error_show(101,'token不能为空');
//    }
//    $effetc = VerifyTokens($token);
//    if(!empty($effetc) && $effetc['code']!=0){
//        return error_show($effetc['code'],$effetc['message']);
//    }
}
public function flist(){
    $page = isset($this->post['page']) &&$this->post['page'] !=="" ? intval($this->post['page']):1;
    $size = isset($this->post['size']) &&$this->post['size'] !=="" ? intval($this->post['size']):10;
    $condtion=[['a.is_del',"=",0],['b.is_del',"=",0],['c.is_del',"=",0]];
    $wsmcode =isset($this->post['wsm_code']) &&$this->post['wsm_code'] !=="" ? trim($this->post['wsm_code']):"";
    if($wsmcode!==""){
        //return error_show(1002,"仓库code不能为空");
        $condtion[]=['c.wsm_code',"=",$wsmcode];
       // $typecode= Db::name("good_stock")->where(["wsm_code"=>$wsmcode,'is_del'=>0])->column("good_type_code");
    }

    $good_code =isset($this->post['type_code']) &&$this->post['type_code'] !=="" ? trim($this->post['type_code']):"";
    if($good_code!=""){
        $condtion[]=['b.type_code',"=",$good_code];
    }
    $goodcode =isset($this->post['good_code']) &&$this->post['good_code'] !=="" ? trim($this->post['good_code'])
        :"";
    if($goodcode!=""){
       // $condtion['a.good_code'] = Db::raw("like '%{$goodcode}%'");
        $condtion[]=['a.good_code',"like","%{$goodcode}%"];
    }
    $good_name =isset($this->post['good_name']) &&$this->post['good_name'] !=="" ? trim($this->post['good_name'])
        :"";
    if($good_name!=""){
      //  $condtion['a.good_name'] = Db::raw("like '%{$good_name}%'");
        $condtion[]=['a.good_name',"like","%{$good_name}%"];
    }
    $supplierNo =isset($this->post['supplierNo']) &&$this->post['supplierNo'] !=="" ? trim($this->post['supplierNo']):"";
    if($supplierNo!=""){
        $supplier = Db::name("supplier")->where(["code"=>$supplierNo])->find();
        if(empty($supplier)){
            return error_show(1004,"未找到供应商信息");
        }
                $wsmcode = Db::name("warehouse_info")->where([
                    "is_del"=>0,"supplierNo"=>$supplierNo])->column("wsm_code");
        //$condtion["c.wsm_code"] = $wsmcode;
        $condtion[]=['c.wsm_code',"in",$wsmcode];
    }
    $stock_low =isset($this->post['stock_low']) &&$this->post['stock_low'] !=="" ? intval($this->post['stock_low'])
        :"";
    if($stock_low!=""){
       // $condtion['c.usable_stock'] = Db::raw(">= $stock_low");
        $condtion[]=['c.usable_stock',">=",$stock_low];
    }
    $stock_up =isset($this->post['stock_up']) &&$this->post['stock_up'] !=="" ? trim($this->post['stock_up'])
        :"";
    if($stock_up!=""){
        $condtion[]=['c.usable_stock',"<=",$stock_up];
    }
    $warn_low =isset($this->post['warn_low']) &&$this->post['warn_low'] !=="" ? intval($this->post['warn_low'])
        :"";
    if($warn_low!==""){
      //  $condtion['c.warn_stock'] = Db::raw(">= $warn_low");
        $condtion[]=['c.warn_stock',">=",$warn_low];
    }
    $warn_up =isset($this->post['warn_up']) &&$this->post['warn_up'] !=="" ? intval($this->post['warn_up'])
        :"";
    if($warn_up!=""){
      //  $condtion['c.warn_stock'] = Db::raw("<= {$warn_up}");
        $condtion[]=['c.warn_stock',"<=",$warn_up];
    }
    $count = Db::name("good_type")->alias("b")
        ->join("good a","a.good_code = b.good_code","left")
        ->join("good_stock c","c.good_type_code=b.type_code","left")
        ->where($condtion)->count();
    $page>=ceil($count/$size) ? $page=ceil($count/$size) :"";
    $list = Db::name("good_type")->alias("b")->join("good a","a.good_code = b.good_code","left")
        ->join("good_stock c","c.good_type_code=b.type_code","left")
        ->where($condtion)->field("c.id,a.good_code,a.good_name,a.good_desc,a.brand,a.original_price,a.cg_saler,a.good_type,a.market_fee,a.gys_code,a.unit,
                a.sort_f,a.sort_s,a.sort_t,b.color,b.material,b.specs,b.is_main,b.type_code,b.attribute,b.status as bstatus,a.addtime,c.wsm_code,c.usable_stock,c.warn_stock,a.updatetime")
        ->page($page,$size)->select();
    $data=[];
    foreach ($list as $key=>$value){
        $supplier = Db::name("supplier")->where(["code"=>$value['gys_code']])->find();
        $value['supplier_name'] =isset($supplier['name']) ?$supplier['name'] :"";
        $wsmcode = Db::name("warehouse_info")->alias("a")->leftJoin("supplier b","a.supplierNo=b.code")->where(["a.wsm_code"=>$value['wsm_code']])->field("a.name as wsm_name,b.name")->find();
        $value['wsm_name'] =isset($wsmcode['wsm_name']) ? $wsmcode['wsm_name']:"";
        $value['wsm_supplier'] =isset($wsmcode['name']) ? $wsmcode['name']:"";
        $data[]=$value;
    }
    return app_show(0,"获取成功",["list"=>$data,"count"=>$count]);
}
public function list()
{
    $page = isset($this->post['page']) && $this->post['page'] !== "" ? intval($this->post['page']) : "1";
    $size = isset($this->post['size']) && $this->post['size'] !== "" ? intval($this->post['size']) : "10";
    $where = [['a.is_del',"=",0],['b.is_del',"=",0]];
    $start= isset($this->post['start']) && $this->post['start'] !== "" ? $this->post['start']:"";
    if ($start !="") {
      //  $where["a.addtime"]=Db::raw(">= '{$start}'");
        $where[]=['a.addtime',">=",$start];
    }
    $end = isset($this->post['end']) && $this->post['end'] !== "" ? $this->post['end'] :"";
    if($end !=""){
      //  $where["a.addtime"] = Db::raw("<= '{$end}'");
        $where[]=['a.addtime',"<=",$end];
    }
    $check_code = isset($this->post['check_code']) && $this->post['check_code'] !== "" ? trim($this->post['check_code']) : "";
    if ($check_code !== "") {
       // $where['a.check_code'] = Db::raw("like '%$check_code%'");
        $where[]=['a.check_code',"like","%$check_code%"];
    }
    $wsm_code = isset($this->post['wsm_code']) && $this->post['wsm_code'] !== "" ? trim($this->post['wsm_code']) : "";
    if ($wsm_code  !== "") {
      //  $where['a.wsm_code'] =  Db::raw("like '%$wsm_code%'");
        $where[]=['a.wsm_code',"like","%$wsm_code%"];
    }
    $apply_name = isset($this->post['apply_name']) && $this->post['apply_name'] !== "" ? trim($this->post['apply_name']) : "";
    if ($apply_name !== "") {
     //   $where['a.apply_name'] = $apply_name;
        $where[]=['a.apply_name',"like","%$apply_name%"];
    }
    $type = isset($this->post['type']) && $this->post['type'] !== "" ? trim($this->post['type']) : "";
    if ($type !== "") {
       // $where['a.type'] = $type;
        $where[]=['a.type',"=",$type];
    }
    $apply_id = isset($this->post['apply_id']) && $this->post['apply_id'] !== "" ? intval($this->post['apply_id']) : "";
    if ($apply_id!== "") {
       // $where['a.apply_id'] = $apply_id;
        $where[]=['a.apply_id',"=",$apply_id];
    }
    $status= isset($this->post['status']) && $this->post['status'] !== "" ? intval($this->post['status']) : "";
    if ($status !== "") {
       // $where['a.status '] = $status;
        $where[]=['a.status',"=",$status];
    }
    $count = Db::name('good_check')->alias('a')->join("warehouse_info b","a.wsm_code = b.wsm_code","left")
        ->join("supplier v","v.code=b.supplierNo","left")
        ->where($where)->count();
    $total = ceil($count / $size);
    $page = $page <= $total ? $page : $total;
    $list = Db::name('good_check')->alias('a')->join("warehouse_info b","a.wsm_code = b.wsm_code","left")
        ->join("supplier v","v.code=b.supplierNo","left")
        ->field("a.status,a.apply_id,a.apply_name,a.type,a.addtime,a.wsm_code,a.check_code,b.name,a.id,v.name as 'caname',v.code")->where($where)->page($page,$size)->order("a.id desc")->select();
    $data=[];
    foreach ($list as $key=>$value){
        $value['rename'] ='';
        if($value['apply_id']!=0){
            $depart = Db::name("depart_user")->alias("a")->leftJoin("company_item b","a.itemid = b.id")->where(['a.uid'=>$value['apply_id'],'a.is_del'=>0])
                ->column('b.name');
           // var_dump(Db::name("depart_user")->getLastSql());
            $value['rename'] =implode(",",$depart);
        }
        $data[] = $value;
    }
    return app_show(0,"获取成功",['count'=>$count,'list'=>$data]);

    }
public function goodlist(){
    $page = isset($this->post['page']) && $this->post['page'] !=="" ? intval($this->post['page']) :"1";
    $size = isset($this->post['size']) && $this->post['size'] !=="" ? intval($this->post['size']) :"10";
    $where = ['is_del'=>0];
    $id = isset($this->post['id']) && $this->post['id'] !=="" ? intval($this->post['id']) :"";
    if($id==""){
        return error_show(1002,"参数id不能为空");
    }
    $fo = Db::name('good_check')->alias('a')->join('warehouse_info b',"b.wsm_code=a.wsm_code","left")
        ->join('supplier c',"c.code=b.supplierNo","left")->field("c.name,c.code,a.*")
        ->where(['a.id'=>$id,'a.is_del'=>0])->find();
    if(empty($fo)){
        return error_show(1003,"未找到盘点信息");
    }
    if ($fo['check_code'] !== "") {
        $where['check_code'] = $fo['check_code'];
    }
    $count = Db::name('check_item')->where($where)->count();
    $total = ceil($count / $size);
    $page = $page >= $total ?  $total: $page;
    $list = Db::name('check_item')->where($where)->page($page,$size)->select();
    return app_show(0,"获取成功",['count'=>$count,'list'=>$list]);
}
public function create(){
    $token =isset($this->post['token']) && $this->post['token'] !=="" ? trim($this->post['token']) :"";

    $wsm_code = isset($this->post['wsm_code']) && $this->post['wsm_code'] !=="" ? trim($this->post['wsm_code']):"";
    if($wsm_code==""){
        return error_show(1002,"盘点仓库编号不能为空");
    }
    $type = isset($this->post['type']) && $this->post['type'] !=="" ? intval($this->post['type']) :"";
    if($type==""){
        return error_show(1002,"盘点类型不能为空");
    }
    $check_code = makeNo("CK");
    $apply_id=GetUserInfo($token);
    if(empty($apply_id)||$apply_id['code']!=0){
        return error_show(1002,"申请人数据不存在");
    }
    $rm= isset($apply_id["data"]['id']) ?  $apply_id["data"]['id'] : "";
    $ri= isset($apply_id["data"]['nickname']) ?  $apply_id["data"]['nickname'] : "";
    $status = isset($this->post['status']) && $this->post['status'] !=="" ? intval($this->post['status']) :"0";
    $remark = isset($this->post['remark']) && $this->post['remark'] !=="" ? intval($this->post['remark']) :"";
//    $dain=isset($this->post['good']) && $this->post['good'] !=="" ? trim($this->post['good']):"";
//    if($type==2){
//        if($dain==""||empty($dain)){
//            return error_show(1002,"商品不能为空");
//        }
//    }else{
//        if($type==1) {
//
//        $dain= Db::name("good_type")->alias("b")->join("good a","a.good_code = b.good_code","left")
//              ->join("good_stock c","c.good_type_code = b.type_code","left")->where(['c.wsm_code'=>$wsm_code,'b.is_del'=>0,'a.is_del'=>0])->where("c.is_del=0 or c.is_del is null")
//              ->field("b.type_code,a.good_name")->select();
//        //var_dump($dain);
//        }
//        if($dain==""){
//            return error_show(1003,"商品不能为空");
//        }
//    }
    Db::startTrans();
    try{
        $data=[
            "check_code"=>$check_code,
            "wsm_code"=>$wsm_code,
            "type"=>$type,
            "status"=>$status,
            "remark"=>$remark,
            "apply_id"=>$rm,
            "apply_name"=>$ri,
            "is_del"=>0,
            "addtime"=>date('Y-m-d H:i:s'),
            "updatetime"=>date("Y-m-d H:i:s")
        ];
        $da= Db::name('good_check')->insert($data,true);
//        $dio=[];
//        if($da>0){
//            foreach ($dain as $value){
//            $st=Db::name("good_type")->alias("b")->join("good a","a.good_code = b.good_code","left")
//                ->join("good_stock c","c.good_type_code = b.type_code","left")->where(['c.wsm_code'=>$wsm_code,'good_type_code'=>$value['type_code'],'b.is_del'=>0,'a.is_del'=>0])->where("c.is_del=0 or c.is_del is null")
//                ->field("b.type_code,a.good_name,c.wsm_code,c.wait_in_stock,c.wait_out_stock,c.usable_stock,c.good_type_code,a.original_price")->find();
//
//            $temp=[];
//            $temp['good_name']=$st['good_name'];
//            $temp['origin_price']=$st['original_price'];
//            $temp['good_type_code']=$st['good_type_code'];
//            $temp['origin_num']=$st['usable_stock'];
//            $temp['check_num']=0;
//            $temp['diff_num']=0;
//            $temp['status']=0;
//            $temp['remark']="";
//            $temp['is_del']=0;
//            $temp['check_time']=date('Y-m-d H:i:s');
//            $temp['check_code']=$check_code;
//            $temp['addtime']=date("Y-m-d H:i:s");
//            $temp['updatetime']=date("Y-m-d H:i:s");
//            $dio[] =$temp;
//            }
//            $in= Db::name('check_item')->insertAll($dio);
//        }
        if($da){
           Db::commit();
            return error_show(0,"盘点创建成功");
        }else{
            Db::rollback();
           return error_show(1002,"创建失败");
        }
    }catch (\Exception $e){
        Db::rollback();
        return error_show(1005,$e->getMessage());
   }
    }
public function info(){
    $id = isset($this->post['id']) && $this->post['id'] !=="" ? intval($this->post['id']) :"";
    if($id==""){
        return error_show(1002,"参数id不能为空");
    }
    $fo = Db::name('good_check')->alias('a')->join('warehouse_info b',"b.wsm_code=a.wsm_code","left")
        ->join('supplier c',"c.code=b.supplierNo","left")->field("c.name,c.code,a.*")
        ->where(['a.id'=>$id,'a.is_del'=>0])->find();
    if(empty($fo)){
        return error_show(1003,"未找到盘点信息");
    }
    $fi = Db::name('check_item')->where(['check_code'=>$fo['check_code'],'is_del'=>0])->select();
    $fo['item']=$fi;
    if(empty($fo)){
        return error_show(1002,"未找到盘点编号");
    }else{
        return app_show(0,"获取成功",$fo);
    }
}
public function edit()
{
    $token =isset($this->post['token']) && $this->post['token'] !=="" ? trim($this->post['token']) :"";
    $id = isset($this->post['id']) && $this->post['id'] !== "" ? intval($this->post['id']) : "";
    $eid = Db::name('good_check')->where(['id' => $id, 'is_del' => 0])->find();
    if ($eid ==="") {
        return error_show(1002, "未找到盘点编号信息");
    }
    $wsm_code = isset($this->post['wsm_code']) && $this->post['wsm_code'] !== "" ? trim($this->post['wsm_code']) : "";
    if ($wsm_code == "") {
        return error_show(1002, "盘点仓库不能为空");
    }
    $type = isset($this->post['type']) && $this->post['type'] !== "" ? trim($this->post['type']) : "";
    $remark = isset($this->post['remark']) && $this->post['remark'] !== "" ? trim($this->post['remark']) : "";
    if ($type == "") {
        return error_show(1002, "盘点类型不能为空");
    }
    $apply_id=GetUserInfo($token);
    if(empty($apply_id)||$apply_id['code']!=0){
        return error_show(1002,"申请人数据不存在");
    }
    $rm= isset($apply_id["data"]['id']) ?  $apply_id["data"]['id'] : "";
    $ri= isset($apply_id["data"]['nickname']) ?  $apply_id["data"]['nickname'] : "";
//    $dain=isset($this->post['good']) && $this->post['good'] !=="" ? $this->post['good']:"";
//    if($type==2){
//       // var_dump($dain);
//        if($dain==""||empty($dain)){
//            return error_show(1002,"商品不能为空");
//        }
//    }else{
//        if($type==1) {
//
//            $dain= Db::name("good_type")->alias("b")->join("good a","a.good_code = b.good_code","left")
//                ->join("good_stock c","c.good_type_code = b.type_code","left")->where(['c.wsm_code'=>$wsm_code,'b.is_del'=>0,'a.is_del'=>0])->where("c.is_del=0 or c.is_del is null")
//                ->field("b.type_code,a.good_name")->select();
//            //var_dump($dain);
//        }
//        if($dain==""){
//            return error_show(1003,"商品不能为空");
//        }
//    }
    Db::startTrans();
    try {
        $var = [
            "wsm_code" => $wsm_code,
            "type" => $type,
            "apply_id" => $rm,
            "apply_name" => $ri,
            "remark" => $remark,
            "updatetime" => date("Y-m-d H:i:s")
        ];
        $up = Db::name('good_check')->where(['id'=>$id,'is_del' => 0])->save($var);
//            $dn =[];
//            if($up>0){
//                foreach ($dain as $value){
//                    $st=Db::name("good_type")->alias("b")->join("good a","a.good_code = b.good_code","left")
//                        ->join("good_stock c","c.good_type_code = b.type_code","left")->where(['c.wsm_code'=>$wsm_code,'good_type_code'=>$value['type_code'],'b.is_del'=>0,'a.is_del'=>0])->where("c.is_del=0 or c.is_del is null")
//                        ->field("b.type_code,a.good_name,c.wsm_code,c.wait_in_stock,c.wait_out_stock,c.usable_stock,c.good_type_code,a.original_price")->find();
//                    $temp=[];
//                    $temp['good_name']=$st['good_name'];
//                    $temp['origin_price']=$st['original_price'];
//                    $temp['good_type_code']=$st['good_type_code'];
//                    $temp['origin_num']=$st['usable_stock'];
//                    $temp['check_num']=0;
//                    $temp['diff_num']=0;
//                    $temp['status']=0;
//                    $temp['remark']="";
//                    $temp['is_del']=0;
//                    $temp['check_time']=date('Y-m-d H:i:s');
//                    $temp['check_code']=$eid['check_code'];
//                    $temp['addtime']=date("Y-m-d H:i:s");
//                    $temp['updatetime']=date("Y-m-d H:i:s");
//                    $dn[] =$temp;
//                }
//                $np = Db::name('check_item')->where(['check_code'=>$eid['check_code'],'is_del'=>0])->update(['is_del'=>1,'updatetime'=>date('Y-m-d H:i:s')]);
//               $io = db::name('check_item')->insertAll($up);
               // var_dump(Db::name('check_item')->getLastSql());
                if ($up) {
                    Db::commit();
                    return error_show(0, "盘点更新成功");
                }

        Db::rollback();
        return error_show(1003,"盘点更新失败");
    } catch (\Exception $e) {
        Db::rollback();
        return error_show(1005, $e->getMessage());
    }
}
public function dell(){
    $id = $this->post['id'] && $this->post['id'] !=="" ? intval($this->post['id']) :"";
    if($id===""){
        return  error_show(1004,"参数id不能为空");
    }
    $deln= Db::name('good_check')->where(['id'=>$id,'is_del'=>0])->find();
    if(empty($deln)){
        return error_show(1002,"未找到数据");
    }
    $sv = Db::name('good_check')->update(['id'=>$id,'is_del'=>1,'updatetime'=>date("Y-m-d H:i:s")]);
    if($sv){
        return error_show(0,"删除成功");
    }else{
        return error_show(1002,"删除失败");
    }
}
    public function statu()
    {
        $id = isset($this->post['id']) && $this->post['id'] !=="" ? intval($this->post['id']) :"";
        if($id==""){
            return error_show(1002,"盘点id不能为空");
        }

        $stauts = isset($this->post['status']) && $this->post['status'] !=="" ? intval($this->post['status']) :"";
        $remark = isset($this->post['remark']) && $this->post['remark'] !=="" ? trim($this->post['remark']) :"";
        if($stauts===""){
            return error_show(1002,"状态不能为空");
        }
        $st = Db::name('good_check')->where(['id'=>$id,"is_del"=>0])->find();
        if(empty($st)){
            return error_show(1002,"盘点信息未找到");
        }
        Db::startTrans();
        try{
            $temp =  $st['status'];
            $st['status']=$stauts;
            $st['remark']=$remark;
            $st['updatetime']= date('Y-m-d H:i:s');
            $sv = Db::name('good_check')->save($st);
            if($sv){
                if($stauts==1&&$temp==2){
                    $up = Db::name('check_item')->where(['check_code'=>$st['check_code'],"is_del"=>0])->save(['is_del'=>1,
                        "updatetime"=>date("Y-m-d H:i:s")]);
                    if($up==false){
                        Db::rollback();
                        return error_show(1003,"盘点结果删除失败");
                    }
                }
                if($stauts==2){
                    $nu = Db::name('check_item')->where(['check_code'=>$st['check_code'],"is_del"=>0])->select()->toArray();
                    if(empty($nu)){
                        Db::rollback();
                        return error_show(1003,"未上传盘点结果");
                    }
                }
                Db::commit();
                return error_show(0,"状态更新成功");
            }
                Db::rollback();
                return error_show(1002,"状态更新失败");
        }catch (\Exception $e){
            Db::rollback();
            return error_show(1002,$e->getMessage());
        }

    }

    public function exportGood(){
        $id = isset($this->post['id']) && $this->post['id'] !=="" ? intval($this->post['id']) :"";
        if($id==""){
            return error_show(1002,"参数id不能为空");
        }
        $fo = Db::name('good_check')->alias('a')->join('warehouse_info b',"b.wsm_code=a.wsm_code","left")
            ->join('supplier c',"c.code=b.supplierNo","left")->field("c.name,c.code,b.name,a.*")
            ->where(['a.id'=>$id,'a.is_del'=>0])->find();
        if(empty($fo)){
            return error_show(1003,"未找到盘点信息");
        }
        $list = Db::name("good_type")->alias("b")->join("good a","a.good_code = b.good_code","left")
            ->join("good_stock c","c.good_type_code=b.type_code","left")
            ->where(['c.wsm_code'=>$fo['wsm_code'],"a.is_del"=>0,"b.is_del"=>0,"c.is_del"=>0])->field("a.good_code '商品编码',b.type_code '商品属性编码',
            a.good_name '商品名称',a.good_desc '商品描述',a.brand '品牌',a.unit '单位',a.gys_code '供应商编码','' as '供应商名称',a.sort_f '一级分类',a.sort_s '二级分类',a.sort_t '三级分类',
            a.addtime '新建时间',c.wsm_code '仓库编码','' as '仓库名称',c.usable_stock '可用库存','' as '盘点库存'")
            ->select();
        $data=[];
        foreach ($list as $key=>$value){
            $wsm = Db::name("warehouse_info")->where(['wsm_code'=>$value['仓库编码']])->find();
            $supplier = Db::name("supplier")->where(["code"=>$value['供应商编码']])->find();
            $value['供应商名称'] =isset($supplier['name']) ?$supplier['name'] :"";
            $value['仓库名称'] =isset($wsm['name']) ?$wsm['name'] :"";
            $data[]=$value;
        }
        if(empty($data)){
            $data[]=["暂无商品信息"=>''];
        }
        $headerArr= array_keys($data[0]);
        excelSave('盘点商品',$headerArr,$data);
       // return app_show(0,"获取成功",$data);
    }

    public function importGood(){
        $id = isset($this->post['id']) && $this->post['id'] !=="" ? intval($this->post['id']) :"";
        if($id==""){
            return error_show(1002,"参数id不能为空");
        }
        $fo = Db::name('good_check')->alias('a')->join('warehouse_info b',"b.wsm_code=a.wsm_code","left")
            ->join('supplier c',"c.code=b.supplierNo","left")->field("c.name,c.code,b.name,a.*")
            ->where(['a.id'=>$id,'a.is_del'=>0])->find();
        if(empty($fo)){
            return error_show(1003,"未找到盘点信息");
        }
        if($fo['status']>=2){
            return error_show(1003,"盘点已提交审核，不可提交盘点数据");
        }
       $data = isset($this->post['data']) && $this->post['data'] !=="" ?$this->post['data'] :"";
        if($data=="" || empty($data)){
            return error_show(1003,"盘点数据不能为空");
        }
        $insert=[];
        foreach ($data as $value){
            if($value["value1"]==""){
                return error_show(1003,"商品属性code 不能为空");
            }
            if($value["value15"]===""){
                continue;
            }
            $stock = Db::name("good_stock")->where(["good_type_code"=>$value["value1"],"wsm_code"=>$fo['wsm_code'],
                "is_del"=>0])->find();
            $stock_num = isset($stock) ? $stock['usable_stock']:0;
            $insert[]=[
                "good_type_code"=>$value["value1"],
                "good_name"=>$value["value2"],
                "origin_price"=>0,
                "origin_num"=>isset($stock) ? $stock['usable_stock']:0,
                "check_num"=>$value["value15"],
                "is_profit"=>intval($value["value15"])>=$stock_num ?0:1,
                "diff_num"=>intval($value["value15"])>=$stock_num ?intval($value["value15"])-$stock_num:$stock_num-intval($value["value15"]),
                'addtime'=>date("Y-m-d H:i:s"),
                'updatetime'=>date("Y-m-d H:i:s"),
                "check_code"=>$fo['check_code']
            ];
        }
        if(empty($insert)){
            return error_show(1003,"盘点数据不可用");
        }
        Db::startTrans();
        try{
            $inst = Db::name("check_item")->insertAll($insert);
            if($inst){
                $check_up = Db::name("good_check")->where(["check_code"=>$fo['check_code'],"is_del"=>0])->save(["status"=>2,"updatetime"=>date("Y-m-d H:i:s")]);
                if($check_up){
                    Db::commit();
                    return app_show(0,"盘点数据导入成功");
                }
            }
            Db::rollback();
           return error_show(1002,"盘点数据导入失败");
        }catch (\Exception $e){
            Db::rollback();
            return error_show(1002,"盘点数据导入失败");
        }

    }
}