<?php
// +----------------------------------------------------------------------
// | ThinkPHP [ WE CAN DO IT JUST THINK ]
// +----------------------------------------------------------------------
// | Copyright (c) 2006~2018 http://thinkphp.cn All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: liu21st <liu21st@gmail.com>
// +----------------------------------------------------------------------
use think\facade\Route;

Route::rule('menu', 'admin/Menu/list');

//Route::rule('menuadd', 'admin/Menu/MenuAdd');
Route::rule('menusave', 'admin/Menu/MenuEdit');
Route::rule('menudel', 'admin/Menu/MenuDel');
Route::rule('menustatus', 'admin/Menu/MenuStatus');
Route::rule("menulist","admin/Menu/MenuAllList");


Route::rule('menuaction', 'admin/Action/ActionList');
Route::rule('menuactionsave', 'admin/Action/ActionSave');
Route::rule('menuactionstatus', 'admin/Action/ActionStatus');
Route::rule('menuactionadd', 'admin/Action/ActionAdd');
Route::rule("menuactionlist","admin/Action/index");
Route::rule("menuactiondel","admin/Menu/MenuActionDel");

Route::rule("actiondata","admin/Action/DataAction");
Route::rule("actionsave","admin/Action/ActionSave");
Route::rule("actionstatus","admin/Action/ActionStatus");
Route::rule("actioninfo","admin/Action/ActionInfo");
Route::rule("actionlist","admin/Action/ActionList");


Route::rule('grouplist', 'admin/Group/GroupList');
Route::rule('groupall', 'admin/Group/GroupAll');
Route::rule('groupinfo', 'admin/Group/GroupInfo');
Route::rule('groupadd', 'admin/Group/GroupAdd');
Route::rule('groupsave', 'admin/Group/GroupSave');
Route::rule('groupstatus', 'admin/Group/GroupStatus');

Route::rule('rolelist', 'admin/Role/RoleList');
Route::rule('roleall', 'admin/Role/RoleAll');
Route::rule('roleinfo', 'admin/Role/RoleInfo');
Route::rule('roleadd', 'admin/Role/RoleAdd');
Route::rule('rolesave', 'admin/Role/RoleSave');
Route::rule('rolestatus', 'admin/Role/RoleStatus');


Route::rule('ulist','admin/Newfill/list');
Route::rule('add','admin/Newfill/add');
Route::rule('refresh',"admin/Newfill/refresh");
Route::rule('query','admin/Newfill/query');
Route::rule('itemdel','admin/Newfill/itemdel');
Route::rule('stat','admin/Newfill/stat');
Route::rule('userp','admin/Newfill/userp');
Route::rule('clist','admin/Departuser/list');
Route::rule('attend','admin/Departuser/attend');
Route::rule('useredit','admin/Departuser/useredit');
Route::rule('ifound','admin/Departuser/found');
Route::rule('iuserdel','admin/Departuser/userdel');

Route::rule('customerlist','admin/Customer/list');
Route::rule('customercreate','admin/Customer/create');
Route::rule('customerupdate','admin/Customer/updat');
Route::rule('customerselect','admin/Customer/selec');
Route::rule('customerdelect','admin/Customer/dell');

Route::rule('supplierlist','admin/Supplier/list');
Route::rule('suppliercreate','admin/Supplier/create');
Route::rule('supplieredit','admin/Supplier/edit');
Route::rule('supplierselec','admin/Supplier/selec');
Route::rule('supplierdelect','admin/Supplier/del');

Route::rule('resultlist','admin/Result/list');
Route::rule('resultcreate','admin/Result/create');
Route::rule('resultselect','admin/Result/selec');
Route::rule('resultedit','admin/Result/edit');
Route::rule('resultdel','admin/Result/del');
Route::rule('resultstatu','admin/Result/statu');

Route::rule('Resigninfolist','admin/Resigninfo/list');
Route::rule('Resigninfocreate','admin/Resigninfo/create');
Route::rule('Resigninfoselect','admin/Resigninfo/selec');
Route::rule('Resigninfoedit','admin/Resigninfo/edit');
Route::rule('Resigninfodel','admin/Resigninfo/del');
Route::rule('Resigninfostatu','admin/Resigninfo/statu');

Route::rule('Consultlist','admin/Consult/list');
Route::rule('Consultinfo','admin/Consult/info');
Route::rule('Consultdel','admin/Consult/del');

Route::rule('infolist','admin/Listcustomer/list');

Route::rule('checkflist','admin/Check/flist');
Route::rule('checklist','admin/Check/list');
Route::rule('checkgood','admin/Check/goodlist');
Route::rule('checkcreate','admin/Check/create');
Route::rule('checkinfo','admin/Check/info');
Route::rule('checkedit','admin/Check/edit');
Route::rule('checkedell','admin/Check/dell');
Route::rule('checkestatus','admin/Check/statu');
Route::rule('checkexport','admin/Check/exportGood');
Route::rule('checkimport','admin/Check/importGood');

//Route::rule('veversioncreatersionlist','admin/Version/list');
//Route::rule('','admin/Version/create');

Route::rule('allotlist','admin/Allot/list');
Route::rule('allotcreate','admin/Allot/create');
Route::rule('allotedit','admin/Allot/edit');
Route::rule('allotinfo','admin/Allot/info');
Route::rule('allotdelect','admin/Allot/del');
Route::rule('allotstatus','admin/Allot/status');
Route::rule('allotgetont','admin/Allot/getont');
Route::rule('allotgetin','admin/Allot/getin');
Route::rule('allotvesio','admin/Allot/vesio');

Route::rule('userlist', 'admin/User/list');
Route::rule('userinfo', 'admin/User/userInfo');
Route::rule('userall', 'admin/User/userAll');
Route::rule("userstatus","admin/User/UserStatus");
Route::rule("usersave","admin/User/UserSave");
Route::rule("passset","admin/User/setPwd");
Route::rule("userinfobyid","admin/User/info");

Route::rule("sharelist","admin/Share/index");
Route::rule("shareadd","admin/Share/create");
Route::rule("sharesave","admin/Share/save");
Route::rule("sharestatus","admin/Share/status");
Route::rule("sharedel","admin/Share/delete");
Route::rule("shareinfo","admin/Share/read");

Route::rule("loglist","admin/System/index");
Route::rule("versionlist","admin/System/version");
Route::rule("lastversion","admin/System/LastVersion");

Route::rule("wareadd","admin/WareHouse/add");
Route::rule("wareinfo","admin/WareHouse/info");
Route::rule("waresave","admin/WareHouse/save");
Route::rule("waredel","admin/WareHouse/delete");
Route::rule("warelist","admin/WareHouse/list");
Route::rule("warestatus","admin/WareHouse/status");

Route::rule("province","admin/Addr/province");
Route::rule("city","admin/Addr/city");
Route::rule("area","admin/Addr/area");

Route::rule("goodlist","admin/Good/list");
Route::rule("goodwarn","admin/Good/SetWarn");
Route::rule("goodstatus","admin/Good/SetStatus");
Route::rule("goodstat","admin/Good/Stat");
Route::rule("goodstock","admin/Good/GetStock");
Route::rule("goodall","admin/Good/all");
Route::rule("getstockgod","admin/Good/GetStockGod");
Route::rule("getstockwsm","admin/Good/GetStockWsm");
Route::rule("getstockbet","admin/Good/GetStockBet");

Route::rule("purchlist","admin/Resign/list");
Route::rule("purchadd","admin/Resign/add");
Route::rule("purchcopy","admin/Resign/copy");
Route::rule("purchedit","admin/Resign/edit");
Route::rule("purchdel","admin/Resign/delete");
Route::rule("purchinfo","admin/Resign/info");
Route::rule("purchstatus","admin/Resign/status");
Route::rule("feedadd","admin/Resign/addFeed");
Route::rule("feeddel","admin/Resign/delFeed");
Route::rule("feedchange","admin/Resign/changeFeed");
Route::rule("feedinfo","admin/Resign/infoFeed");

Route::rule("cgdlist","admin/Purch/list");
Route::rule("cgdinfo","admin/Purch/info");
Route::rule("cgdedit","admin/Purch/edit");
Route::rule("cgdstatus","admin/Purch/status");

Route::rule("orderinadd","admin/Purchin/add");
Route::rule("orderininfo","admin/Purchin/info");
Route::rule("orderincheck","admin/Purchin/check");
Route::rule("orderinstatus","admin/Purchin/status");
Route::rule("orderinreturn","admin/Purchin/ReturnAdd");



